﻿/*
 * Erstellt mit SharpDevelop.
 * Benutzer: Hauptnutzer
 * Datum: 25.01.2011
 * Zeit: 10:30
 * 
 * Sie können diese Vorlage unter Extras > Optionen > Codeerstellung > Standardheader ändern.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using ZweiDimensionalerRegressator;
using System.ComponentModel;
using System.Collections.Generic;

namespace Newton_Optimisation_Bench
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		int NumberOBetasphericDimensions = 2;
		double[] Vec1;
		double[] Vec2;
		double[,] DeltaMat;
		double[,] Alpha;
		double[,] AlphaVariable;
		
		double[] Gamma;
		double[] GammaVariable;
		
		bool RunningStressTest;
		bool StopStressTest;
		
		DateTime StartZeit;
		
		int NumberOfIterations;
		double AveragePoints;
		
		List<myDouble> PointsGroup;
		
		
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			


			InitializeBackgroundWorker();
			myBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(this.UpdateStatusAtTheEnd);
			
			// Combo-Boxen in Oberfläche füllen
			comboBox_Priority.SelectedIndex = 1;
			textBox_Points.Text = System.Environment.ProcessorCount.ToString();
			int NumberOfCPUCounts = Convert.ToInt32(textBox_Points.Text);
			textBox_Points.Text = "";
			comboBox_CoreAffinity.Items.Clear();
			comboBox_CoreAffinity.Items.Add("all");
			for (int i = 0; i < NumberOfCPUCounts; i++)
				comboBox_CoreAffinity.Items.Add(i.ToString());
			comboBox_CoreAffinity.SelectedIndex = 0;
			
			RunningStressTest = false;
			StopStressTest = false;
			
			NumberOfIterations = -1;
			PointsGroup = new List<myDouble>();
		}
		
		
		
		void StartBenchmarkClick(object sender, EventArgs e)
		{
			comboBox_CoreAffinity.Enabled = false;
			comboBox_Priority.Enabled = false;
			// Kernzuordnung setzen
			{
				// long CoreAffinity = 0;
				if (comboBox_CoreAffinity.SelectedIndex > 0)
				{
					long CoreAffinity = (long) (comboBox_CoreAffinity.SelectedIndex-1);
					// textBox_Points.Text = CoreAffinity.ToString();
					
					System.Diagnostics.Process.GetCurrentProcess().ProcessorAffinity = (System.IntPtr) (Math.Pow(2, CoreAffinity));
				}
				else
				{
					long AllCores = 0;
					for (int i = 0; i < System.Environment.ProcessorCount; i++)
						AllCores = AllCores + (long) (Math.Pow(2, i));
							System.Diagnostics.Process.GetCurrentProcess().ProcessorAffinity = (System.IntPtr) AllCores;
				}
					
			}
			// Priorität setzen
			if (comboBox_Priority.SelectedIndex == 0)
				System.Diagnostics.Process.GetCurrentProcess().PriorityClass = System.Diagnostics.ProcessPriorityClass.BelowNormal;
			if (comboBox_Priority.SelectedIndex == 1)
				System.Diagnostics.Process.GetCurrentProcess().PriorityClass = System.Diagnostics.ProcessPriorityClass.Normal;
			if (comboBox_Priority.SelectedIndex == 2)
				System.Diagnostics.Process.GetCurrentProcess().PriorityClass = System.Diagnostics.ProcessPriorityClass.High;
			
			if (RunningStressTest == true)
			{
				RunningStressTest = false;
				StopStressTest = true;
				button_StartBenchmark.Text = "Start Benchmark";
				textBox_Time.Text = "stopping ...";
				textBox_Points.Text = "... kernel";
				myBackgroundWorker.CancelAsync();
				return;
			}
			
			if (myBackgroundWorker.IsBusy)
			{
				return;
			}
			
			if (RunningStressTest == false)
			{
				RunningStressTest = true;
				StopStressTest = false;
				if (NumberOfIterations == -1)
				{
					NumberOfIterations = 0;
					AveragePoints = 0;
					PointsGroup.Clear();
					textBox_Time.Text = "benching ...";
					textBox_Points.Text = "benching ...";
					
				}
				
				
				
			}
			

			
			

			
			StartZeit = DateTime.Now;
			button_StartBenchmark.Text = "Stop Benchmark";
			
			
			myBackgroundWorker.RunWorkerAsync();

			
		}
		
		void UpdateStatusAtTheEnd(object sender, RunWorkerCompletedEventArgs e)
		{
			if (!StopStressTest)
			{
				// Berechnung der Punkte und Zeit
				DateTime EndZeit = DateTime.Now;
				TimeSpan Diff = EndZeit - StartZeit;
				if (Diff.TotalMilliseconds == 0)
				{
					textBox_Time.Text = "Error";
					textBox_Points.Text = "Error";
					return;
				}
				textBox_Time.Text = Math.Round((Diff.TotalMilliseconds/1000),3).ToString();
				double Points = Math.Round(4.477 /  (Diff.TotalMilliseconds / 1000),4);
				textBox_Points.Text = Points.ToString();
				button_StartBenchmark.Enabled = true;
				
				NumberOfIterations++;
				myDouble newPointValue = new myDouble();
				
				newPointValue.DoubleValues = Points;
				
				PointsGroup.Add(newPointValue);
				
				//AveragePoints = ( (double)NumberOfIterations - 1) / ( (double)NumberOfIterations) * AveragePoints + ( 1.0 / (double) NumberOfIterations) * Points;
				
				
				
				
			}
			else
			{
				textBox_Time.Text = "done " + NumberOfIterations.ToString() + " iterations - ready to restart";
				
				AveragePoints = 0;
				for (int i = 0; i < PointsGroup.Count; i++)
					AveragePoints = AveragePoints + PointsGroup[i].DoubleValues;
				AveragePoints = AveragePoints / (double) PointsGroup.Count;
				
				double StandardDev = 0;
				if (PointsGroup.Count > 1)
				{
					for (int i = 0; i < PointsGroup.Count; i++)
						StandardDev = StandardDev + 1.0 / ((double) PointsGroup.Count -1) * (PointsGroup[i].DoubleValues - AveragePoints) * (PointsGroup[i].DoubleValues - AveragePoints) ;
					
					StandardDev = Math.Sqrt(StandardDev);
				}
				textBox_Points.Text = "average: " + (Math.Round(AveragePoints,4) ).ToString() + " StdDev: " + Math.Round(StandardDev,5).ToString();
				
				PointsGroup.Clear();
				NumberOfIterations = -1;
			}
			

			button_StartBenchmark.Text = "Start Benchmark";
			comboBox_CoreAffinity.Enabled = true;
			comboBox_Priority.Enabled = true;
			
			EventArgs e2 = new EventArgs();
			RunningStressTest = false;
			if (!StopStressTest)
			{
				StartBenchmarkClick(sender, e2);
			}
		}
		
		
		
		void SetModellParameters()
		{
			
			Gamma = new double[NumberOBetasphericDimensions];
			GammaVariable = new double[NumberOBetasphericDimensions];
			for (int i = 0; i < NumberOBetasphericDimensions; i++)
			{
				Gamma[i] = (i + 1) * 1e-9;
				GammaVariable[i] = 1;
			}
			
			Alpha = new double[NumberOBetasphericDimensions, Vec2.Length];
			AlphaVariable = new double[NumberOBetasphericDimensions, Vec2.Length];
			for (int i = 0; i < NumberOBetasphericDimensions; i++)
			{
				for (int j = 0; j < Vec2.Length; j++)
				{
					Alpha[i,j] = 1 / ( (double) NumberOBetasphericDimensions);
					AlphaVariable[i,j] = 1d;
				}
			}
			
		}
		
		void SetGlobalParameterSystemValues(object sender, EventArgs e)
		{
			
			Vec1 = new double[24];
			Vec2 = new double[34];
			for (int measuringpoints = 0; measuringpoints < Vec2.Length; measuringpoints++)
			{
				Vec2[measuringpoints] = measuringpoints;
			}
			DeltaMat = new double[Vec1.Length,Vec2.Length];
			Vec1[0] = 5000000.0 ;
			DeltaMat[0,0] = 0.106325421450389;
			DeltaMat[0,1] = 0.102258887058816;
			DeltaMat[0,2] = 0.102167888675146;
			DeltaMat[0,3] = 0.0944612441107553;
			DeltaMat[0,4] = 0.0933750374616995;
			DeltaMat[0,5] = 0.0886606271788259;
			DeltaMat[0,6] = 0.0824264052288168;
			DeltaMat[0,7] = 0.0772964869394721;
			DeltaMat[0,8] = 0.0714467639382563;
			DeltaMat[0,9] = 0.0673998363074528;
			DeltaMat[0,10] = 0.0590562904823031;
			DeltaMat[0,11] = 0.0544841906691369;
			DeltaMat[0,12] = 0.0506720064021657;
			DeltaMat[0,13] = 0.0457485425895674;
			DeltaMat[0,14] = 0.0423233374187917;
			DeltaMat[0,15] = 0.0398890240505381;
			DeltaMat[0,16] = 0.0371011634717302;
			DeltaMat[0,17] = 0.0349238139511252;
			DeltaMat[0,18] = 0.0332838390906978;
			DeltaMat[0,19] = 0.0322612732878644;
			DeltaMat[0,20] = 0.0328265453910537;
			DeltaMat[0,21] = 0.032767413943233;
			DeltaMat[0,22] = 0.0322587344447189;
			DeltaMat[0,23] = 0.0318156464519614;
			DeltaMat[0,24] = 0.0317331043042384;
			DeltaMat[0,25] = 0.0319611584816974;
			DeltaMat[0,26] = 0.0317185533932289;
			DeltaMat[0,27] = 0.0312894864183604;
			DeltaMat[0,28] = 0.0313856545477;
			DeltaMat[0,29] = 0.031165456189248;
			DeltaMat[0,30] = 0.0308237312449202;
			DeltaMat[0,31] = 0.0307397651532078;
			DeltaMat[0,32] = 0.0287697236310707;
			DeltaMat[0,33] = 0.0280251195664833;
			Vec1[1] = 6000000.0 ;
			DeltaMat[1,0] = 0.140074938183717;
			DeltaMat[1,1] = 0.133860534749866;
			DeltaMat[1,2] = 0.128445937232987;
			DeltaMat[1,3] = 0.122626524363685;
			DeltaMat[1,4] = 0.122413697251273;
			DeltaMat[1,5] = 0.113987947403829;
			DeltaMat[1,6] = 0.105774414746825;
			DeltaMat[1,7] = 0.0986541737299471;
			DeltaMat[1,8] = 0.0924652536071009;
			DeltaMat[1,9] = 0.0818579899703864;
			DeltaMat[1,10] = 0.0747047463236372;
			DeltaMat[1,11] = 0.0685247544491294;
			DeltaMat[1,12] = 0.062912610548445;
			DeltaMat[1,13] = 0.0584064377371853;
			DeltaMat[1,14] = 0.0536271646252837;
			DeltaMat[1,15] = 0.0504098423933343;
			DeltaMat[1,16] = 0.0466869163242278;
			DeltaMat[1,17] = 0.0434380177216966;
			DeltaMat[1,18] = 0.0424895885949872;
			DeltaMat[1,19] = 0.0416996357428672;
			DeltaMat[1,20] = 0.0412373920823068;
			DeltaMat[1,21] = 0.0404789877004714;
			DeltaMat[1,22] = 0.0412990787977932;
			DeltaMat[1,23] = 0.0410072881438075;
			DeltaMat[1,24] = 0.0407971894847141;
			DeltaMat[1,25] = 0.0407884952254016;
			DeltaMat[1,26] = 0.0409585219485775;
			DeltaMat[1,27] = 0.040767875943958;
			DeltaMat[1,28] = 0.0405939418929822;
			DeltaMat[1,29] = 0.0395587550494914;
			DeltaMat[1,30] = 0.0391605152074588;
			DeltaMat[1,31] = 0.0384876790727477;
			DeltaMat[1,32] = 0.0370016540266431;
			DeltaMat[1,33] = 0.0360839891818174;
			Vec1[2] = 7000000.0 ;
			DeltaMat[2,0] = 0.189657404135515;
			DeltaMat[2,1] = 0.183679885962904;
			DeltaMat[2,2] = 0.175775563985539;
			DeltaMat[2,3] = 0.170503110456183;
			DeltaMat[2,4] = 0.16345836925194;
			DeltaMat[2,5] = 0.153839271901961;
			DeltaMat[2,6] = 0.144723910071852;
			DeltaMat[2,7] = 0.137111888969382;
			DeltaMat[2,8] = 0.123849590356343;
			DeltaMat[2,9] = 0.115178411177002;
			DeltaMat[2,10] = 0.103331500795467;
			DeltaMat[2,11] = 0.0931679931361029;
			DeltaMat[2,12] = 0.0862101475285204;
			DeltaMat[2,13] = 0.0807726644867084;
			DeltaMat[2,14] = 0.0717495712811784;
			DeltaMat[2,15] = 0.0665158494598281;
			DeltaMat[2,16] = 0.0631167562241735;
			DeltaMat[2,17] = 0.0592027980087475;
			DeltaMat[2,18] = 0.0573542341625077;
			DeltaMat[2,19] = 0.0560134292389063;
			DeltaMat[2,20] = 0.055108124571857;
			DeltaMat[2,21] = 0.0546634120838054;
			DeltaMat[2,22] = 0.054823902992851;
			DeltaMat[2,23] = 0.0542996810706491;
			DeltaMat[2,24] = 0.0541467335461139;
			DeltaMat[2,25] = 0.0535278970295097;
			DeltaMat[2,26] = 0.0538923000413463;
			DeltaMat[2,27] = 0.0543493692016095;
			DeltaMat[2,28] = 0.0537318638372488;
			DeltaMat[2,29] = 0.0529148342783281;
			DeltaMat[2,30] = 0.0518326188810154;
			DeltaMat[2,31] = 0.0508071005393838;
			DeltaMat[2,32] = 0.0498731433489539;
			DeltaMat[2,33] = 0.0478770929087475;
			Vec1[3] = 8000000.0 ;
			DeltaMat[3,0] = 0.180973540983471;
			DeltaMat[3,1] = 0.174380525259731;
			DeltaMat[3,2] = 0.166431419592605;
			DeltaMat[3,3] = 0.164071900616019;
			DeltaMat[3,4] = 0.156336559666289;
			DeltaMat[3,5] = 0.147508315150573;
			DeltaMat[3,6] = 0.140085157782997;
			DeltaMat[3,7] = 0.130917042136264;
			DeltaMat[3,8] = 0.120446094897637;
			DeltaMat[3,9] = 0.109875456824116;
			DeltaMat[3,10] = 0.0996624323000175;
			DeltaMat[3,11] = 0.0903116533043193;
			DeltaMat[3,12] = 0.0825894528978699;
			DeltaMat[3,13] = 0.0769511327769554;
			DeltaMat[3,14] = 0.0714558048180636;
			DeltaMat[3,15] = 0.0658141473627047;
			DeltaMat[3,16] = 0.0608473304866499;
			DeltaMat[3,17] = 0.0579414905353182;
			DeltaMat[3,18] = 0.0560070217071491;
			DeltaMat[3,19] = 0.0547119847549746;
			DeltaMat[3,20] = 0.0523034916504419;
			DeltaMat[3,21] = 0.0534914097607992;
			DeltaMat[3,22] = 0.0540438425943579;
			DeltaMat[3,23] = 0.0526153577484378;
			DeltaMat[3,24] = 0.0535807504739965;
			DeltaMat[3,25] = 0.0527629391922804;
			DeltaMat[3,26] = 0.0535546901347241;
			DeltaMat[3,27] = 0.0520325522893663;
			DeltaMat[3,28] = 0.0523837981219315;
			DeltaMat[3,29] = 0.051199805088129;
			DeltaMat[3,30] = 0.0509360251654138;
			DeltaMat[3,31] = 0.0501952043325118;
			DeltaMat[3,32] = 0.0476533979281024;
			DeltaMat[3,33] = 0.0464156067968386;
			Vec1[4] = 9000000.0 ;
			DeltaMat[4,0] = 0.1862111659883;
			DeltaMat[4,1] = 0.18295223092199;
			DeltaMat[4,2] = 0.171671764537919;
			DeltaMat[4,3] = 0.168306754982396;
			DeltaMat[4,4] = 0.161385935724986;
			DeltaMat[4,5] = 0.150676801821007;
			DeltaMat[4,6] = 0.138357199948611;
			DeltaMat[4,7] = 0.129781190365074;
			DeltaMat[4,8] = 0.119559310571576;
			DeltaMat[4,9] = 0.107976758963582;
			DeltaMat[4,10] = 0.0991522215173917;
			DeltaMat[4,11] = 0.0904397226717393;
			DeltaMat[4,12] = 0.0803020160287891;
			DeltaMat[4,13] = 0.0761750953537783;
			DeltaMat[4,14] = 0.0696715553240326;
			DeltaMat[4,15] = 0.0640031554920419;
			DeltaMat[4,16] = 0.0593872431809634;
			DeltaMat[4,17] = 0.0562052764979426;
			DeltaMat[4,18] = 0.0538636665441738;
			DeltaMat[4,19] = 0.0533158147402752;
			DeltaMat[4,20] = 0.0503868124705775;
			DeltaMat[4,21] = 0.0508478482072658;
			DeltaMat[4,22] = 0.0516218824001178;
			DeltaMat[4,23] = 0.0518413931248505;
			DeltaMat[4,24] = 0.051992362947773;
			DeltaMat[4,25] = 0.051282810314218;
			DeltaMat[4,26] = 0.0512425875652012;
			DeltaMat[4,27] = 0.0506112857449232;
			DeltaMat[4,28] = 0.050726545966072;
			DeltaMat[4,29] = 0.0500618543705893;
			DeltaMat[4,30] = 0.048417076869621;
			DeltaMat[4,31] = 0.0477484132019717;
			DeltaMat[4,32] = 0.0467638520281195;
			DeltaMat[4,33] = 0.0447531041277727;
			Vec1[5] = 10000000.0 ;
			DeltaMat[5,0] = 0.247805834902673;
			DeltaMat[5,1] = 0.239387319894288;
			DeltaMat[5,2] = 0.233555545995077;
			DeltaMat[5,3] = 0.225495786591531;
			DeltaMat[5,4] = 0.215867313210045;
			DeltaMat[5,5] = 0.206934737130976;
			DeltaMat[5,6] = 0.193141175278723;
			DeltaMat[5,7] = 0.178794646557825;
			DeltaMat[5,8] = 0.165044354926287;
			DeltaMat[5,9] = 0.149828677393995;
			DeltaMat[5,10] = 0.136926991975308;
			DeltaMat[5,11] = 0.123413419766579;
			DeltaMat[5,12] = 0.110102801923419;
			DeltaMat[5,13] = 0.102868466044383;
			DeltaMat[5,14] = 0.0939252788355067;
			DeltaMat[5,15] = 0.0876920914056445;
			DeltaMat[5,16] = 0.0817106847959854;
			DeltaMat[5,17] = 0.0773632568818092;
			DeltaMat[5,18] = 0.0745682525335756;
			DeltaMat[5,19] = 0.0725825119495971;
			DeltaMat[5,20] = 0.071500460362742;
			DeltaMat[5,21] = 0.0708338891029174;
			DeltaMat[5,22] = 0.0698123100996155;
			DeltaMat[5,23] = 0.070230610243847;
			DeltaMat[5,24] = 0.0705560908928078;
			DeltaMat[5,25] = 0.0690401384661503;
			DeltaMat[5,26] = 0.0704170009124967;
			DeltaMat[5,27] = 0.069497697069258;
			DeltaMat[5,28] = 0.0686245541563184;
			DeltaMat[5,29] = 0.0674807048153396;
			DeltaMat[5,30] = 0.0668205510992919;
			DeltaMat[5,31] = 0.06595097787427;
			DeltaMat[5,32] = 0.0629955002926148;
			DeltaMat[5,33] = 0.0626204341451997;
			Vec1[6] = 11000000.0 ;
			DeltaMat[6,0] = 0.221932359837494;
			DeltaMat[6,1] = 0.215046472238701;
			DeltaMat[6,2] = 0.20827447202052;
			DeltaMat[6,3] = 0.199061293267549;
			DeltaMat[6,4] = 0.189797628710445;
			DeltaMat[6,5] = 0.184446362129509;
			DeltaMat[6,6] = 0.169882794362397;
			DeltaMat[6,7] = 0.160355241467972;
			DeltaMat[6,8] = 0.148022019163841;
			DeltaMat[6,9] = 0.133731914722854;
			DeltaMat[6,10] = 0.121258169851002;
			DeltaMat[6,11] = 0.110776803224784;
			DeltaMat[6,12] = 0.102356206817813;
			DeltaMat[6,13] = 0.0940652988908646;
			DeltaMat[6,14] = 0.0862933343044565;
			DeltaMat[6,15] = 0.0799265750612896;
			DeltaMat[6,16] = 0.0744712218252181;
			DeltaMat[6,17] = 0.0701003430085634;
			DeltaMat[6,18] = 0.0680785452173129;
			DeltaMat[6,19] = 0.0663313981934301;
			DeltaMat[6,20] = 0.0654856311688365;
			DeltaMat[6,21] = 0.0653961886208743;
			DeltaMat[6,22] = 0.0655958995128914;
			DeltaMat[6,23] = 0.0642589359621581;
			DeltaMat[6,24] = 0.0656397998587366;
			DeltaMat[6,25] = 0.0658719989570566;
			DeltaMat[6,26] = 0.065535620172458;
			DeltaMat[6,27] = 0.0649476253249603;
			DeltaMat[6,28] = 0.0639090066362762;
			DeltaMat[6,29] = 0.0631754254418131;
			DeltaMat[6,30] = 0.061702709316827;
			DeltaMat[6,31] = 0.0601604908108198;
			DeltaMat[6,32] = 0.0591594948700025;
			DeltaMat[6,33] = 0.0583653841295813;
			Vec1[7] = 12000000.0 ;
			DeltaMat[7,0] = 0.265213606421047;
			DeltaMat[7,1] = 0.257402077109238;
			DeltaMat[7,2] = 0.247493007580631;
			DeltaMat[7,3] = 0.235444926983587;
			DeltaMat[7,4] = 0.223058579369399;
			DeltaMat[7,5] = 0.215107258906155;
			DeltaMat[7,6] = 0.199868219613607;
			DeltaMat[7,7] = 0.18675084404078;
			DeltaMat[7,8] = 0.170321761904488;
			DeltaMat[7,9] = 0.157081671467423;
			DeltaMat[7,10] = 0.142409143163206;
			DeltaMat[7,11] = 0.127878510662423;
			DeltaMat[7,12] = 0.117459120275641;
			DeltaMat[7,13] = 0.108146500022059;
			DeltaMat[7,14] = 0.0987111058146395;
			DeltaMat[7,15] = 0.0921915043672659;
			DeltaMat[7,16] = 0.086267311788816;
			DeltaMat[7,17] = 0.081020049602242;
			DeltaMat[7,18] = 0.0789795166934333;
			DeltaMat[7,19] = 0.0746379204593208;
			DeltaMat[7,20] = 0.0745068107072617;
			DeltaMat[7,21] = 0.073947138527263;
			DeltaMat[7,22] = 0.0739269872467831;
			DeltaMat[7,23] = 0.0745135690106928;
			DeltaMat[7,24] = 0.0739949432609848;
			DeltaMat[7,25] = 0.074655215865203;
			DeltaMat[7,26] = 0.0738689331381095;
			DeltaMat[7,27] = 0.0731691183613092;
			DeltaMat[7,28] = 0.0730209129920358;
			DeltaMat[7,29] = 0.0712300822577308;
			DeltaMat[7,30] = 0.0718570283049651;
			DeltaMat[7,31] = 0.0693713457313598;
			DeltaMat[7,32] = 0.0659305199199776;
			DeltaMat[7,33] = 0.066522162116275;
			Vec1[8] = 13000000.0 ;
			DeltaMat[8,0] = 0.272683032134855;
			DeltaMat[8,1] = 0.266110188496773;
			DeltaMat[8,2] = 0.256295880909047;
			DeltaMat[8,3] = 0.244787583816519;
			DeltaMat[8,4] = 0.235999421600842;
			DeltaMat[8,5] = 0.226009664735787;
			DeltaMat[8,6] = 0.213775294593491;
			DeltaMat[8,7] = 0.196696472908232;
			DeltaMat[8,8] = 0.178656254861977;
			DeltaMat[8,9] = 0.163538481845049;
			DeltaMat[8,10] = 0.150701875787676;
			DeltaMat[8,11] = 0.135033862588724;
			DeltaMat[8,12] = 0.122594414675779;
			DeltaMat[8,13] = 0.11449500631112;
			DeltaMat[8,14] = 0.105042933297228;
			DeltaMat[8,15] = 0.10040452170554;
			DeltaMat[8,16] = 0.0917346514552961;
			DeltaMat[8,17] = 0.0866482079828357;
			DeltaMat[8,18] = 0.0847645459161552;
			DeltaMat[8,19] = 0.0827866601131078;
			DeltaMat[8,20] = 0.0807078830825048;
			DeltaMat[8,21] = 0.0808033952662588;
			DeltaMat[8,22] = 0.0805392701841665;
			DeltaMat[8,23] = 0.0808178014462282;
			DeltaMat[8,24] = 0.0808768613812583;
			DeltaMat[8,25] = 0.0811766859708039;
			DeltaMat[8,26] = 0.0812060590909525;
			DeltaMat[8,27] = 0.0806366986533571;
			DeltaMat[8,28] = 0.0786220096883903;
			DeltaMat[8,29] = 0.0784693864856627;
			DeltaMat[8,30] = 0.0767784760102637;
			DeltaMat[8,31] = 0.0753564826196307;
			DeltaMat[8,32] = 0.073999197910172;
			DeltaMat[8,33] = 0.07236749502193;
			Vec1[9] = 15000000.0 ;
			DeltaMat[9,0] = 0.31558644444763;
			DeltaMat[9,1] = 0.303265809698257;
			DeltaMat[9,2] = 0.293556828186847;
			DeltaMat[9,3] = 0.28225599466014;
			DeltaMat[9,4] = 0.275184983367508;
			DeltaMat[9,5] = 0.25721831785431;
			DeltaMat[9,6] = 0.240750410934508;
			DeltaMat[9,7] = 0.223577005679877;
			DeltaMat[9,8] = 0.205989435503591;
			DeltaMat[9,9] = 0.189131507950779;
			DeltaMat[9,10] = 0.173207641617696;
			DeltaMat[9,11] = 0.158963920275804;
			DeltaMat[9,12] = 0.146975434204345;
			DeltaMat[9,13] = 0.135403003191683;
			DeltaMat[9,14] = 0.12690572851481;
			DeltaMat[9,15] = 0.118659905473314;
			DeltaMat[9,16] = 0.109961825351539;
			DeltaMat[9,17] = 0.104150619168342;
			DeltaMat[9,18] = 0.101173419800938;
			DeltaMat[9,19] = 0.0982719731862594;
			DeltaMat[9,20] = 0.0980812092352834;
			DeltaMat[9,21] = 0.0973858429940231;
			DeltaMat[9,22] = 0.097102898661122;
			DeltaMat[9,23] = 0.0973370470490351;
			DeltaMat[9,24] = 0.0965392016075077;
			DeltaMat[9,25] = 0.097951604206856;
			DeltaMat[9,26] = 0.0975759626439094;
			DeltaMat[9,27] = 0.0955429230630991;
			DeltaMat[9,28] = 0.0954854631817825;
			DeltaMat[9,29] = 0.0947331788164107;
			DeltaMat[9,30] = 0.0934369820858509;
			DeltaMat[9,31] = 0.0909772540780531;
			DeltaMat[9,32] = 0.0880589979763005;
			DeltaMat[9,33] = 0.0873303548958824;
			Vec1[10] = 16000000.0 ;
			DeltaMat[10,0] = 0.289896022179207;
			DeltaMat[10,1] = 0.26943770907325;
			DeltaMat[10,2] = 0.273014691163663;
			DeltaMat[10,3] = 0.252261506323149;
			DeltaMat[10,4] = 0.241987995224458;
			DeltaMat[10,5] = 0.228289775573093;
			DeltaMat[10,6] = 0.214806153147204;
			DeltaMat[10,7] = 0.201386833562982;
			DeltaMat[10,8] = 0.182286191432455;
			DeltaMat[10,9] = 0.168170741254581;
			DeltaMat[10,10] = 0.153116514790681;
			DeltaMat[10,11] = 0.137757965942181;
			DeltaMat[10,12] = 0.12402444279058;
			DeltaMat[10,13] = 0.112844730294055;
			DeltaMat[10,14] = 0.105159456839578;
			DeltaMat[10,15] = 0.101161854898921;
			DeltaMat[10,16] = 0.0921686898274181;
			DeltaMat[10,17] = 0.0849307201235603;
			DeltaMat[10,18] = 0.0844854275334461;
			DeltaMat[10,19] = 0.0839251364302618;
			DeltaMat[10,20] = 0.0796595374382247;
			DeltaMat[10,21] = 0.0783706539847249;
			DeltaMat[10,22] = 0.0810538139066905;
			DeltaMat[10,23] = 0.0789356329899393;
			DeltaMat[10,24] = 0.0813386846642663;
			DeltaMat[10,25] = 0.0812684909614061;
			DeltaMat[10,26] = 0.0803646259283559;
			DeltaMat[10,27] = 0.0806515366618974;
			DeltaMat[10,28] = 0.0793260851985507;
			DeltaMat[10,29] = 0.0760056598186569;
			DeltaMat[10,30] = 0.0762778521697545;
			DeltaMat[10,31] = 0.0740621400586006;
			DeltaMat[10,32] = 0.0751941172666408;
			DeltaMat[10,33] = 0.0727008828429567;
			Vec1[11] = 17000000.0 ;
			DeltaMat[11,0] = 0.352223916658429;
			DeltaMat[11,1] = 0.340169239660728;
			DeltaMat[11,2] = 0.32396170119865;
			DeltaMat[11,3] = 0.318611007739192;
			DeltaMat[11,4] = 0.306804738744524;
			DeltaMat[11,5] = 0.286640453242683;
			DeltaMat[11,6] = 0.270485315686788;
			DeltaMat[11,7] = 0.254480024748187;
			DeltaMat[11,8] = 0.231289751233423;
			DeltaMat[11,9] = 0.209321265701729;
			DeltaMat[11,10] = 0.190531664405779;
			DeltaMat[11,11] = 0.177813866924017;
			DeltaMat[11,12] = 0.162959470145359;
			DeltaMat[11,13] = 0.151947357472506;
			DeltaMat[11,14] = 0.138737154216793;
			DeltaMat[11,15] = 0.130603038737151;
			DeltaMat[11,16] = 0.119706252359172;
			DeltaMat[11,17] = 0.117240178129804;
			DeltaMat[11,18] = 0.112090760272494;
			DeltaMat[11,19] = 0.10925778695143;
			DeltaMat[11,20] = 0.108200549785921;
			DeltaMat[11,21] = 0.106354640160751;
			DeltaMat[11,22] = 0.106473992898173;
			DeltaMat[11,23] = 0.107672632601658;
			DeltaMat[11,24] = 0.106927380850866;
			DeltaMat[11,25] = 0.107909517514447;
			DeltaMat[11,26] = 0.108461104524394;
			DeltaMat[11,27] = 0.109756321870141;
			DeltaMat[11,28] = 0.10601861535133;
			DeltaMat[11,29] = 0.102854255504282;
			DeltaMat[11,30] = 0.101630277184357;
			DeltaMat[11,31] = 0.0996268741071168;
			DeltaMat[11,32] = 0.0960231883490905;
			DeltaMat[11,33] = 0.095053617723754;
			Vec1[12] = 18000000.0 ;
			DeltaMat[12,0] = 0.353601851790336;
			DeltaMat[12,1] = 0.332451661592075;
			DeltaMat[12,2] = 0.322633861446113;
			DeltaMat[12,3] = 0.308881535313336;
			DeltaMat[12,4] = 0.29443360476222;
			DeltaMat[12,5] = 0.283722172354455;
			DeltaMat[12,6] = 0.266306848681292;
			DeltaMat[12,7] = 0.245742198817663;
			DeltaMat[12,8] = 0.227484137051041;
			DeltaMat[12,9] = 0.204206439438224;
			DeltaMat[12,10] = 0.191590248285492;
			DeltaMat[12,11] = 0.176495603056854;
			DeltaMat[12,12] = 0.160216294772043;
			DeltaMat[12,13] = 0.15176146224511;
			DeltaMat[12,14] = 0.142093217856199;
			DeltaMat[12,15] = 0.135367352970056;
			DeltaMat[12,16] = 0.124978519180339;
			DeltaMat[12,17] = 0.121347225428737;
			DeltaMat[12,18] = 0.114159005539783;
			DeltaMat[12,19] = 0.112744624722558;
			DeltaMat[12,20] = 0.111130219954048;
			DeltaMat[12,21] = 0.110671623544652;
			DeltaMat[12,22] = 0.110034957599187;
			DeltaMat[12,23] = 0.111147156969356;
			DeltaMat[12,24] = 0.109555609054787;
			DeltaMat[12,25] = 0.110055602020167;
			DeltaMat[12,26] = 0.11053009786746;
			DeltaMat[12,27] = 0.11000705818264;
			DeltaMat[12,28] = 0.108600451359674;
			DeltaMat[12,29] = 0.108730588495862;
			DeltaMat[12,30] = 0.105020840224114;
			DeltaMat[12,31] = 0.105683390748068;
			DeltaMat[12,32] = 0.0995424387573461;
			DeltaMat[12,33] = 0.0981267739067601;
			Vec1[13] = 19000000.0 ;
			DeltaMat[13,0] = 0.329265010066578;
			DeltaMat[13,1] = 0.319928005434393;
			DeltaMat[13,2] = 0.303726091561196;
			DeltaMat[13,3] = 0.293680234376994;
			DeltaMat[13,4] = 0.272921415101654;
			DeltaMat[13,5] = 0.261093952545705;
			DeltaMat[13,6] = 0.247488845328005;
			DeltaMat[13,7] = 0.224445336873361;
			DeltaMat[13,8] = 0.211760600654578;
			DeltaMat[13,9] = 0.188473809721269;
			DeltaMat[13,10] = 0.172038122286079;
			DeltaMat[13,11] = 0.152664573021827;
			DeltaMat[13,12] = 0.143875978941884;
			DeltaMat[13,13] = 0.137165632426575;
			DeltaMat[13,14] = 0.120014567677426;
			DeltaMat[13,15] = 0.116010460307898;
			DeltaMat[13,16] = 0.105007346649677;
			DeltaMat[13,17] = 0.0998581264916926;
			DeltaMat[13,18] = 0.0966517916892545;
			DeltaMat[13,19] = 0.0930650293593734;
			DeltaMat[13,20] = 0.0899122358762617;
			DeltaMat[13,21] = 0.0888795859948086;
			DeltaMat[13,22] = 0.0897610739133598;
			DeltaMat[13,23] = 0.0905807682650662;
			DeltaMat[13,24] = 0.0910869400404985;
			DeltaMat[13,25] = 0.0920464395128509;
			DeltaMat[13,26] = 0.092832703851811;
			DeltaMat[13,27] = 0.0926726644901482;
			DeltaMat[13,28] = 0.0890257014340317;
			DeltaMat[13,29] = 0.0908480480480833;
			DeltaMat[13,30] = 0.0886860661402462;
			DeltaMat[13,31] = 0.0851348032427611;
			DeltaMat[13,32] = 0.0854381123709684;
			DeltaMat[13,33] = 0.0797206349450532;
			Vec1[14] = 20000000.0 ;
			DeltaMat[14,0] = 0.403620763604226;
			DeltaMat[14,1] = 0.407880006818326;
			DeltaMat[14,2] = 0.364795048555733;
			DeltaMat[14,3] = 0.366470292518072;
			DeltaMat[14,4] = 0.348621931445825;
			DeltaMat[14,5] = 0.332429199292542;
			DeltaMat[14,6] = 0.304668122736987;
			DeltaMat[14,7] = 0.285588919270804;
			DeltaMat[14,8] = 0.267194330313708;
			DeltaMat[14,9] = 0.238893044922056;
			DeltaMat[14,10] = 0.219237322884352;
			DeltaMat[14,11] = 0.206816920660389;
			DeltaMat[14,12] = 0.191442011410653;
			DeltaMat[14,13] = 0.178537974433302;
			DeltaMat[14,14] = 0.165773665513487;
			DeltaMat[14,15] = 0.153929233291446;
			DeltaMat[14,16] = 0.146704967850038;
			DeltaMat[14,17] = 0.136961478301274;
			DeltaMat[14,18] = 0.133132452048157;
			DeltaMat[14,19] = 0.128818298982082;
			DeltaMat[14,20] = 0.125161466873421;
			DeltaMat[14,21] = 0.129195364168551;
			DeltaMat[14,22] = 0.126568589085767;
			DeltaMat[14,23] = 0.126733064038419;
			DeltaMat[14,24] = 0.125890397371986;
			DeltaMat[14,25] = 0.12742869277471;
			DeltaMat[14,26] = 0.129212332955072;
			DeltaMat[14,27] = 0.126306873812614;
			DeltaMat[14,28] = 0.126855910663697;
			DeltaMat[14,29] = 0.126229871921184;
			DeltaMat[14,30] = 0.120153858235448;
			DeltaMat[14,31] = 0.117779781148382;
			DeltaMat[14,32] = 0.115182123207207;
			DeltaMat[14,33] = 0.112566678519524;
			Vec1[15] = 21000000.0 ;
			DeltaMat[15,0] = 0.359725171309414;
			DeltaMat[15,1] = 0.350084648625967;
			DeltaMat[15,2] = 0.344878516380516;
			DeltaMat[15,3] = 0.335526439488161;
			DeltaMat[15,4] = 0.323170188426776;
			DeltaMat[15,5] = 0.30055556340043;
			DeltaMat[15,6] = 0.280708193140903;
			DeltaMat[15,7] = 0.268158934414643;
			DeltaMat[15,8] = 0.249099349340815;
			DeltaMat[15,9] = 0.226452929083947;
			DeltaMat[15,10] = 0.204608991860314;
			DeltaMat[15,11] = 0.182194553489153;
			DeltaMat[15,12] = 0.177774705367046;
			DeltaMat[15,13] = 0.163439752007013;
			DeltaMat[15,14] = 0.152432267418948;
			DeltaMat[15,15] = 0.141723378812122;
			DeltaMat[15,16] = 0.134699995904265;
			DeltaMat[15,17] = 0.132464816675998;
			DeltaMat[15,18] = 0.129814383392834;
			DeltaMat[15,19] = 0.126346883742882;
			DeltaMat[15,20] = 0.12420010614436;
			DeltaMat[15,21] = 0.124689192296871;
			DeltaMat[15,22] = 0.122690422877934;
			DeltaMat[15,23] = 0.127155835777298;
			DeltaMat[15,24] = 0.122918474249243;
			DeltaMat[15,25] = 0.122815108009714;
			DeltaMat[15,26] = 0.122697346492298;
			DeltaMat[15,27] = 0.123485667421456;
			DeltaMat[15,28] = 0.120356619061066;
			DeltaMat[15,29] = 0.120918589132437;
			DeltaMat[15,30] = 0.117025561307409;
			DeltaMat[15,31] = 0.115860868669338;
			DeltaMat[15,32] = 0.112973062882577;
			DeltaMat[15,33] = 0.106558190329234;
			Vec1[16] = 22000000.0 ;
			DeltaMat[16,0] = 0.386926892765833;
			DeltaMat[16,1] = 0.36586083437567;
			DeltaMat[16,2] = 0.364454559634101;
			DeltaMat[16,3] = 0.350351212948347;
			DeltaMat[16,4] = 0.318427020348893;
			DeltaMat[16,5] = 0.311085019298202;
			DeltaMat[16,6] = 0.290947657818788;
			DeltaMat[16,7] = 0.263267608928688;
			DeltaMat[16,8] = 0.237603348746309;
			DeltaMat[16,9] = 0.22073357223743;
			DeltaMat[16,10] = 0.195992180074332;
			DeltaMat[16,11] = 0.178027852469219;
			DeltaMat[16,12] = 0.168992936803872;
			DeltaMat[16,13] = 0.156341125095026;
			DeltaMat[16,14] = 0.148027116883049;
			DeltaMat[16,15] = 0.145890406811478;
			DeltaMat[16,16] = 0.127605946115985;
			DeltaMat[16,17] = 0.121293963678763;
			DeltaMat[16,18] = 0.120870479022895;
			DeltaMat[16,19] = 0.112886389169232;
			DeltaMat[16,20] = 0.11184745715831;
			DeltaMat[16,21] = 0.115717097470295;
			DeltaMat[16,22] = 0.11380346371727;
			DeltaMat[16,23] = 0.113025731636786;
			DeltaMat[16,24] = 0.114338115165832;
			DeltaMat[16,25] = 0.112740684753364;
			DeltaMat[16,26] = 0.113740674049348;
			DeltaMat[16,27] = 0.112520678308926;
			DeltaMat[16,28] = 0.113242841508047;
			DeltaMat[16,29] = 0.107586422296701;
			DeltaMat[16,30] = 0.108540787490282;
			DeltaMat[16,31] = 0.107010926115827;
			DeltaMat[16,32] = 0.105230850900508;
			DeltaMat[16,33] = 0.100034778987989;
			Vec1[17] = 24000000.0 ;
			DeltaMat[17,0] = 0.420860516321744;
			DeltaMat[17,1] = 0.388868385694138;
			DeltaMat[17,2] = 0.381628332591041;
			DeltaMat[17,3] = 0.376981798661076;
			DeltaMat[17,4] = 0.353902162665313;
			DeltaMat[17,5] = 0.347158331251622;
			DeltaMat[17,6] = 0.329520915633988;
			DeltaMat[17,7] = 0.299561831343739;
			DeltaMat[17,8] = 0.274850791088947;
			DeltaMat[17,9] = 0.251078717636054;
			DeltaMat[17,10] = 0.237509068180998;
			DeltaMat[17,11] = 0.221108921013476;
			DeltaMat[17,12] = 0.198155774816009;
			DeltaMat[17,13] = 0.192693707390228;
			DeltaMat[17,14] = 0.179243197348673;
			DeltaMat[17,15] = 0.1722199438269;
			DeltaMat[17,16] = 0.164558949652071;
			DeltaMat[17,17] = 0.146903816113565;
			DeltaMat[17,18] = 0.148388172238502;
			DeltaMat[17,19] = 0.144226811236061;
			DeltaMat[17,20] = 0.135691535492578;
			DeltaMat[17,21] = 0.14094918659714;
			DeltaMat[17,22] = 0.145629501318505;
			DeltaMat[17,23] = 0.142729137659399;
			DeltaMat[17,24] = 0.145690265615423;
			DeltaMat[17,25] = 0.146368474973899;
			DeltaMat[17,26] = 0.146496061035974;
			DeltaMat[17,27] = 0.143924885438775;
			DeltaMat[17,28] = 0.139710591462904;
			DeltaMat[17,29] = 0.140160299875915;
			DeltaMat[17,30] = 0.137417899911814;
			DeltaMat[17,31] = 0.133900563350319;
			DeltaMat[17,32] = 0.129630310438513;
			DeltaMat[17,33] = 0.121141755454317;
			Vec1[18] = 25000000.0 ;
			DeltaMat[18,0] = 0.409529668306161;
			DeltaMat[18,1] = 0.392752396571852;
			DeltaMat[18,2] = 0.391313646948311;
			DeltaMat[18,3] = 0.368388269101505;
			DeltaMat[18,4] = 0.366783236633922;
			DeltaMat[18,5] = 0.325602385824767;
			DeltaMat[18,6] = 0.309730248383838;
			DeltaMat[18,7] = 0.289077347120403;
			DeltaMat[18,8] = 0.264903548961732;
			DeltaMat[18,9] = 0.236877205252903;
			DeltaMat[18,10] = 0.218701962269343;
			DeltaMat[18,11] = 0.203182124888294;
			DeltaMat[18,12] = 0.192583656207969;
			DeltaMat[18,13] = 0.183223420552614;
			DeltaMat[18,14] = 0.173561484168872;
			DeltaMat[18,15] = 0.161699685581886;
			DeltaMat[18,16] = 0.153989594579771;
			DeltaMat[18,17] = 0.146240577528819;
			DeltaMat[18,18] = 0.145065823201659;
			DeltaMat[18,19] = 0.141699417711019;
			DeltaMat[18,20] = 0.135941907276527;
			DeltaMat[18,21] = 0.139719108960116;
			DeltaMat[18,22] = 0.137079352063611;
			DeltaMat[18,23] = 0.134529592489288;
			DeltaMat[18,24] = 0.137846309360371;
			DeltaMat[18,25] = 0.134454834548608;
			DeltaMat[18,26] = 0.140708020638651;
			DeltaMat[18,27] = 0.13645641592845;
			DeltaMat[18,28] = 0.137285708006924;
			DeltaMat[18,29] = 0.132307617636985;
			DeltaMat[18,30] = 0.128812708339303;
			DeltaMat[18,31] = 0.129464080736994;
			DeltaMat[18,32] = 0.125923214014731;
			DeltaMat[18,33] = 0.12329448370858;
			Vec1[19] = 26000000.0 ;
			DeltaMat[19,0] = 0.404262752977392;
			DeltaMat[19,1] = 0.400979999303305;
			DeltaMat[19,2] = 0.395623158319135;
			DeltaMat[19,3] = 0.370097408483954;
			DeltaMat[19,4] = 0.348505888696976;
			DeltaMat[19,5] = 0.327791350106377;
			DeltaMat[19,6] = 0.310169342809279;
			DeltaMat[19,7] = 0.294376619330031;
			DeltaMat[19,8] = 0.270303111015207;
			DeltaMat[19,9] = 0.244403277427009;
			DeltaMat[19,10] = 0.221323211184307;
			DeltaMat[19,11] = 0.211624538352517;
			DeltaMat[19,12] = 0.194048954927922;
			DeltaMat[19,13] = 0.174494264281106;
			DeltaMat[19,14] = 0.170375001652937;
			DeltaMat[19,15] = 0.158687731736633;
			DeltaMat[19,16] = 0.154900997635004;
			DeltaMat[19,17] = 0.142514543170842;
			DeltaMat[19,18] = 0.137489462685049;
			DeltaMat[19,19] = 0.140299932044575;
			DeltaMat[19,20] = 0.133371029209062;
			DeltaMat[19,21] = 0.135527980047219;
			DeltaMat[19,22] = 0.139042482822425;
			DeltaMat[19,23] = 0.137996246830564;
			DeltaMat[19,24] = 0.137687765902671;
			DeltaMat[19,25] = 0.14076017193654;
			DeltaMat[19,26] = 0.140822614142922;
			DeltaMat[19,27] = 0.13943889205198;
			DeltaMat[19,28] = 0.143078600287223;
			DeltaMat[19,29] = 0.133206242878813;
			DeltaMat[19,30] = 0.13279915209039;
			DeltaMat[19,31] = 0.128669915386316;
			DeltaMat[19,32] = 0.127244350065054;
			DeltaMat[19,33] = 0.124993115565202;
			Vec1[20] = 27000000.0 ;
			DeltaMat[20,0] = 0.397236640932905;
			DeltaMat[20,1] = 0.415033924769461;
			DeltaMat[20,2] = 0.394617291712432;
			DeltaMat[20,3] = 0.394832341967397;
			DeltaMat[20,4] = 0.361944281026901;
			DeltaMat[20,5] = 0.343732730410009;
			DeltaMat[20,6] = 0.328122353482574;
			DeltaMat[20,7] = 0.312183316296593;
			DeltaMat[20,8] = 0.282362938200641;
			DeltaMat[20,9] = 0.259792415686731;
			DeltaMat[20,10] = 0.238564395042379;
			DeltaMat[20,11] = 0.219125971077729;
			DeltaMat[20,12] = 0.212860927990796;
			DeltaMat[20,13] = 0.189039811679171;
			DeltaMat[20,14] = 0.187415456364171;
			DeltaMat[20,15] = 0.172580493621494;
			DeltaMat[20,16] = 0.163464069231198;
			DeltaMat[20,17] = 0.162249020877159;
			DeltaMat[20,18] = 0.14675242740745;
			DeltaMat[20,19] = 0.148475992888334;
			DeltaMat[20,20] = 0.152911480372232;
			DeltaMat[20,21] = 0.147862613838579;
			DeltaMat[20,22] = 0.148960376246324;
			DeltaMat[20,23] = 0.148207147994555;
			DeltaMat[20,24] = 0.149025681688058;
			DeltaMat[20,25] = 0.14990255965567;
			DeltaMat[20,26] = 0.152070428886327;
			DeltaMat[20,27] = 0.14981973956406;
			DeltaMat[20,28] = 0.149257095922581;
			DeltaMat[20,29] = 0.146783903304866;
			DeltaMat[20,30] = 0.148494321846476;
			DeltaMat[20,31] = 0.140156650346387;
			DeltaMat[20,32] = 0.140003040448175;
			DeltaMat[20,33] = 0.133473188348609;
			Vec1[21] = 28000000.0 ;
			DeltaMat[21,0] = 0.48150082057702;
			DeltaMat[21,1] = 0.490737477176407;
			DeltaMat[21,2] = 0.443697818783071;
			DeltaMat[21,3] = 0.413924053103999;
			DeltaMat[21,4] = 0.404716974758011;
			DeltaMat[21,5] = 0.389291775307898;
			DeltaMat[21,6] = 0.368801330604859;
			DeltaMat[21,7] = 0.334351278507934;
			DeltaMat[21,8] = 0.314327526119808;
			DeltaMat[21,9] = 0.284845532124433;
			DeltaMat[21,10] = 0.254658420991661;
			DeltaMat[21,11] = 0.247605303883735;
			DeltaMat[21,12] = 0.222589282130467;
			DeltaMat[21,13] = 0.215680053281664;
			DeltaMat[21,14] = 0.200431468530866;
			DeltaMat[21,15] = 0.188327452693726;
			DeltaMat[21,16] = 0.181760626956429;
			DeltaMat[21,17] = 0.175028101251488;
			DeltaMat[21,18] = 0.166695041611358;
			DeltaMat[21,19] = 0.164229476483041;
			DeltaMat[21,20] = 0.165576170930348;
			DeltaMat[21,21] = 0.163030259824231;
			DeltaMat[21,22] = 0.161572134734582;
			DeltaMat[21,23] = 0.161620254379089;
			DeltaMat[21,24] = 0.162298096695198;
			DeltaMat[21,25] = 0.162491177634876;
			DeltaMat[21,26] = 0.167009378214653;
			DeltaMat[21,27] = 0.161461319852131;
			DeltaMat[21,28] = 0.161658969570786;
			DeltaMat[21,29] = 0.159366546607918;
			DeltaMat[21,30] = 0.159054169980233;
			DeltaMat[21,31] = 0.156250372727078;
			DeltaMat[21,32] = 0.153138061146146;
			DeltaMat[21,33] = 0.152895938623908;
			Vec1[22] = 29000000.0 ;
			DeltaMat[22,0] = 0.417884877010072;
			DeltaMat[22,1] = 0.443693448689314;
			DeltaMat[22,2] = 0.409165157136576;
			DeltaMat[22,3] = 0.395815636853896;
			DeltaMat[22,4] = 0.394894316933949;
			DeltaMat[22,5] = 0.357574035929674;
			DeltaMat[22,6] = 0.339457278551286;
			DeltaMat[22,7] = 0.306179621858967;
			DeltaMat[22,8] = 0.290515714163189;
			DeltaMat[22,9] = 0.273259923394547;
			DeltaMat[22,10] = 0.248079539325794;
			DeltaMat[22,11] = 0.234147841862177;
			DeltaMat[22,12] = 0.214080372331253;
			DeltaMat[22,13] = 0.200677481921729;
			DeltaMat[22,14] = 0.191135340769107;
			DeltaMat[22,15] = 0.181566131872248;
			DeltaMat[22,16] = 0.173981355939693;
			DeltaMat[22,17] = 0.163975939067795;
			DeltaMat[22,18] = 0.159655237834707;
			DeltaMat[22,19] = 0.158394671447041;
			DeltaMat[22,20] = 0.157561731528805;
			DeltaMat[22,21] = 0.156846471920922;
			DeltaMat[22,22] = 0.154961474029192;
			DeltaMat[22,23] = 0.158817873357094;
			DeltaMat[22,24] = 0.161818207368038;
			DeltaMat[22,25] = 0.160080457674961;
			DeltaMat[22,26] = 0.158534207102204;
			DeltaMat[22,27] = 0.162631986398035;
			DeltaMat[22,28] = 0.156987730646188;
			DeltaMat[22,29] = 0.155519879282601;
			DeltaMat[22,30] = 0.155682532448242;
			DeltaMat[22,31] = 0.147548322624063;
			DeltaMat[22,32] = 0.14264659814386;
			DeltaMat[22,33] = 0.143170372695166;
			Vec1[23] = 30000000.0 ;
			DeltaMat[23,0] = 0.432014369159529;
			DeltaMat[23,1] = 0.399151693654495;
			DeltaMat[23,2] = 0.405946173139398;
			DeltaMat[23,3] = 0.392505339845056;
			DeltaMat[23,4] = 0.383421665906783;
			DeltaMat[23,5] = 0.360798658055106;
			DeltaMat[23,6] = 0.339135680324965;
			DeltaMat[23,7] = 0.309759798036743;
			DeltaMat[23,8] = 0.267738612306921;
			DeltaMat[23,9] = 0.260205240583153;
			DeltaMat[23,10] = 0.246670276847993;
			DeltaMat[23,11] = 0.229609824068074;
			DeltaMat[23,12] = 0.214905350324164;
			DeltaMat[23,13] = 0.202978854683891;
			DeltaMat[23,14] = 0.195559319735873;
			DeltaMat[23,15] = 0.176709336976674;
			DeltaMat[23,16] = 0.167898628136316;
			DeltaMat[23,17] = 0.165289583028013;
			DeltaMat[23,18] = 0.16012103829178;
			DeltaMat[23,19] = 0.158271294590457;
			DeltaMat[23,20] = 0.15281765396561;
			DeltaMat[23,21] = 0.156995684143192;
			DeltaMat[23,22] = 0.154261500296721;
			DeltaMat[23,23] = 0.156773454324818;
			DeltaMat[23,24] = 0.157307434469629;
			DeltaMat[23,25] = 0.159299731580842;
			DeltaMat[23,26] = 0.160797961934701;
			DeltaMat[23,27] = 0.160688059203653;
			DeltaMat[23,28] = 0.154478409344496;
			DeltaMat[23,29] = 0.155102513797734;
			DeltaMat[23,30] = 0.154194497790921;
			DeltaMat[23,31] = 0.147063367862098;
			DeltaMat[23,32] = 0.140459242672074;
			DeltaMat[23,33] = 0.144709743371591;






		}

	}
	
	// Enthält die Sachen für den Background-Worker
	public partial class MainForm : Form
	{
		private void InitializeBackgroundWorker()
		{
			
			myBackgroundWorker.DoWork +=new DoWorkEventHandler
				(myBackgroundWorker_DoWork);
			myBackgroundWorker.ProgressChanged += new ProgressChangedEventHandler
				(myBackgroundWorker_ProgressChanged);
			myBackgroundWorker.RunWorkerCompleted +=
				new RunWorkerCompletedEventHandler(
					myBackgroundWorker_RunWorkerCompleted);
			myBackgroundWorker.WorkerReportsProgress = true;
			myBackgroundWorker.WorkerSupportsCancellation = true;
		}
		
		
		void myBackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
		{

			
			
			if (e.Error != null)
			{
				MessageBox.Show(e.Error.Message);
			}
		}

		void myBackgroundWorker_ProgressChanged(object sender, ProgressChangedEventArgs e)
		{
		}

		private void myBackgroundWorker_DoWork(object sender, DoWorkEventArgs e)
		{
			BackgroundWorker worker = sender as BackgroundWorker;
			
			

			SetGlobalParameterSystemValues(sender, e);
			MessParameter myMessParameter = new MessParameter(Vec1,Vec2);
			Funktionswertberechnung FWB = new Funktionswertberechnung(ref myMessParameter);
			Regressator myReg = new Regressator(FWB, myMessParameter);
			{
				myReg.Abbruchdifferential = 1e-8;
			}
			
			SetModellParameters();
			
			ModellParameter myModel = new ModellParameter((uint)NumberOBetasphericDimensions, (uint) Vec2.Length);
			{
				myModel.Betas = Alpha;
				myModel.AlphaIsVariable = AlphaVariable;
				myModel.Gammas = Gamma;
				myModel.GammaVariabel = GammaVariable;
				myModel.NormiereBetasSummenAufEins();
				myModel.BerechneAlphasAusBetas();
			}
			
			Messwerte myMesswerte = new Messwerte(myMessParameter);
			myMesswerte.DeltaMat = DeltaMat;
			myReg.Optimiere2(myMesswerte, myModel);
			
			
			
		}

		
		
	}
	
	public class myDouble
	{
		private double _DoubleValue;
		
		public myDouble()
		{
			
		}
		
		public double DoubleValues
		{
			set {
				_DoubleValue = value;
			}
			get {
				return _DoubleValue;
			}
		}
		
		
		
	}
	
}
