﻿
using System;

namespace ZweiDimensionalerRegressator
{
	
	public class Differenzierer
	{
		private Funktionswertberechnung myFWB;

		private MessParameter myMessparameter;
		private double relativeAbtastschrittbreite;
		
		public Differenzierer( ref Funktionswertberechnung _FWB, double _relativeAbtastschrittbreite)
		{

			if (_FWB == null)
				throw new ArgumentException("Übergebener Funktionswertberechner nicht instanziert");
			
			myFWB = _FWB;
			myMessparameter = myFWB.myMessParameter;

			if (relativeAbtastschrittbreite == 1)
				throw new ArgumentException("relativeAbtastschritt = 0 - unsinnige Einstellung");
			relativeAbtastschrittbreite = _relativeAbtastschrittbreite;
		}
		

		
		public double Abtastbreite
		{
			get {
				return relativeAbtastschrittbreite;
			}
			set {
				relativeAbtastschrittbreite = value;
			}
		}
		
		public ModellParameter Calc_partFF_nach_pModell_FastPath(ref Messwerte _Messwerte, ref ModellParameter _Modellparameter, ref ModellParameter pFFnMP)
		{

			
			
			ModellParameter variierteModellparameter = new ModellParameter(_Modellparameter.NumberOBetasphericDimensions, _Modellparameter.Vec2Length);
			variierteModellparameter = _Modellparameter.ErstelleWertKopie(ref _Modellparameter, ref variierteModellparameter);
			
			
			pFFnMP.IstGradient = true;

			int j;
			Fehlerfunktion myFehlerfunktion = new Fehlerfunktion(myMessparameter);
			double AlterParameterWert;
			double AlteFehlerbewertung = myFehlerfunktion.BewerteRegression(ref _Messwerte, ref _Modellparameter);
			

			double[] OldFFthroughVec2 = new double[myMessparameter.Vec2.Length];
			for (j = 0; j < myMessparameter.Vec2.Length; j++)
				OldFFthroughVec2[j] = myFehlerfunktion.BewerteRegressionForVector2(ref _Messwerte, ref _Modellparameter, j);
			
			
			//double NeueFehlerbewertung;
			
			for (int i = 0; i < pFFnMP.Gammas.Length; i++)
			{
				// Erst nach den Alphas ableiten
				for (j = 0; j < pFFnMP.Vec2Length; j++)
				{

					if (_Modellparameter.AlphaIsVariable[i,j] == 0)
					{
						pFFnMP.Betas[i,j] = 0;
						continue;
					}
					

					AlterParameterWert = variierteModellparameter.Betas[i,j];
					variierteModellparameter.Betas[i,j] = variierteModellparameter.Betas[i,j] + ( relativeAbtastschrittbreite - 1);
					

					

					pFFnMP.Betas[i,j] = (myFehlerfunktion.BewerteRegressionForVector2(ref _Messwerte, ref variierteModellparameter, j) - OldFFthroughVec2[j]) / (relativeAbtastschrittbreite -1);

					variierteModellparameter.Betas[i,j] = AlterParameterWert;
				}
				
				

				

				if (_Modellparameter.GammaVariabel[i] == 0)
				{
					pFFnMP.Gammas[i] = 0;
					continue;
				}
				
				AlterParameterWert = variierteModellparameter.Gammas[i];
				variierteModellparameter.Gammas[i] = variierteModellparameter.Gammas[i] * relativeAbtastschrittbreite;
				pFFnMP.Gammas[i] = myFehlerfunktion.BewerteRegression(ref _Messwerte, ref variierteModellparameter) - AlteFehlerbewertung;
				variierteModellparameter.Gammas[i] = AlterParameterWert;

				
			}
			return pFFnMP;
		}
		
		
		public void SetzeNeueRelativeAbtastschrittbreite(double _relativeAbtastschrittbreite)
		{
			relativeAbtastschrittbreite = _relativeAbtastschrittbreite;
		}
		
		
	}
}
