﻿using System;

namespace ZweiDimensionalerRegressator
{

	public class Fehlerfunktion
	{
		private MessParameter myMessparameter;
		
		
		
		public Fehlerfunktion(MessParameter _MessParameter)
		{
			if (_MessParameter == null)
				throw new ArgumentException("Übergebene Messparameter nicht instanziert");
			myMessparameter = _MessParameter;
		}
		
		public double BewerteRegression(ref Messwerte _Messwerte, ref ModellParameter _ModellParameter )
		{
			int j;
			double Bewertung = 0;
			
			Funktionswertberechnung FWB = new Funktionswertberechnung(ref myMessparameter);
			// TODO: Nicht jedes Mal neu instanzieren
			double[,] ModellMat = FWB.Calc_DeltaMatModell(_ModellParameter);
			
			for (int i = 0; i < myMessparameter.Vec1.Length; i++)
			{
				for (j = 0; j < myMessparameter.Vec2.Length; j++)
				{
					Bewertung = Bewertung + (_Messwerte.DeltaMat[i,j] - ModellMat[i,j])*(_Messwerte.DeltaMat[i,j] - ModellMat[i,j]);
				}
			}
			int FreieParameter = _ModellParameter.GebeAnzahlFreierParameter();
			if (FreieParameter == 0)
				return Math.Sqrt(Bewertung);
				return Math.Sqrt(Bewertung / ( (myMessparameter.Vec1.Length * myMessparameter.Vec2.Length)  - FreieParameter));
		}
		
		
		
		public double BewerteRegressionForVector2(ref Messwerte _Messwerte, ref ModellParameter _ModellParameter, int Vec2Stelle)
		{
			
			double Bewertung = 0;
			
			Funktionswertberechnung FWB = new Funktionswertberechnung(ref myMessparameter);
			double[] BerechneterVector = FWB.Calc_DeltaMatVectorModell(_ModellParameter, Vec2Stelle);
			
			// Quadratische Fehlersumme bilden
			for (int i = 0; i < myMessparameter.Vec1.Length; i++)
			{
					Bewertung = Bewertung + (_Messwerte.DeltaMat[i,Vec2Stelle] - BerechneterVector[i])*(_Messwerte.DeltaMat[i,Vec2Stelle] - BerechneterVector[i]);
			}
			
			int FreieParameter = _ModellParameter.GebeAnzahlFreierParameter();
			if (FreieParameter == 0)
				return Bewertung;
			else
				return Bewertung / ( (myMessparameter.Vec1.Length * myMessparameter.Vec2.Length)  - FreieParameter);
		}
	}
}
