﻿
using System;

namespace ZweiDimensionalerRegressator
{
	
	public class Funktionswertberechnung
	{
		public MessParameter myMessParameter;
		
		public Funktionswertberechnung(ref MessParameter _MessParameter)
		{
			myMessParameter = _MessParameter;
		}
		
		public double[,] Calc_DeltaMatModell(ModellParameter _ModellParameter)
		{

			double[,] DeltaMat = new double[myMessParameter.Vec1.Length,myMessParameter.Vec2.Length];
			

			double Zeta;
			double Epsilon; 
			
			// Zählvariablen
			int k = 0;
			int j = 0;
			
			_ModellParameter.BerechneAlphasAusBetas();
			
			
			// Für alle Werte der Messmatrix
			for (int i = 0; i < myMessParameter.Vec1.Length; i++)
			{
				for (j = 0; j < myMessParameter.Vec2.Length; j++)
				{
					Zeta = 0;
					Epsilon = 0;
					

					for (k = 0; k < _ModellParameter.Gammas.Length; k++)
					{
						Zeta = Zeta + _ModellParameter.Alphas[k,j] * myMessParameter.Vec3[i] * _ModellParameter.Gammas[k] * _ModellParameter.Gammas[k] / ( 1 + myMessParameter.Vec3[i]*myMessParameter.Vec3[i]  *  _ModellParameter.Gammas[k]*_ModellParameter.Gammas[k]);
						Epsilon = Epsilon + _ModellParameter.Alphas[k,j] * _ModellParameter.Gammas[k] /   ( 1 + myMessParameter.Vec3[i]*myMessParameter.Vec3[i] * _ModellParameter.Gammas[k]*_ModellParameter.Gammas[k]);
					}
					DeltaMat[i,j] = Math.Atan(Zeta / Epsilon);
				}
			}
			return DeltaMat;
		}
		
		
		public double[] Calc_DeltaMatVectorModell(ModellParameter _ModellParameter, int Vec2Stelle)
		{
			// neue Matrix erzeugen
			double[] DeltaMatVector = new double[myMessParameter.Vec1.Length];

			double Zeta;
			double Epsilon;
			
			int k = 0;
			int j = 0;
			
			_ModellParameter.BerechneAlphasAusBetas();
			

			for (int i = 0; i < myMessParameter.Vec1.Length; i++)
			{
				for (j = Vec2Stelle; j <= Vec2Stelle; j++)
				{
					Zeta = 0;
					Epsilon = 0;

					

					for (k = 0; k < _ModellParameter.Gammas.Length; k++)
					{
						Zeta = Zeta + _ModellParameter.Alphas[k,j] * myMessParameter.Vec3[i] * _ModellParameter.Gammas[k]*_ModellParameter.Gammas[k] / ( 1 + myMessParameter.Vec3[i]*myMessParameter.Vec3[i] * _ModellParameter.Gammas[k]*_ModellParameter.Gammas[k]);
						Epsilon = Epsilon + _ModellParameter.Alphas[k,j] * _ModellParameter.Gammas[k]  /   ( 1 + myMessParameter.Vec3[i]*myMessParameter.Vec3[i] * _ModellParameter.Gammas[k]*_ModellParameter.Gammas[k]);
					}
					DeltaMatVector[i] = Math.Atan(Zeta/Epsilon);
					
				}
			}
			return DeltaMatVector;
		}
		
		
	}
}
