﻿
using System;

namespace ZweiDimensionalerRegressator
{

	public class Regressator
	{
		private Funktionswertberechnung myFWB;
		private MessParameter myMessparameter;
		private double _Abbruchdifferential;

		
		public Regressator(Funktionswertberechnung _FWB, MessParameter _Messparameter)
		{
			if (_FWB == null)
				throw new ArgumentException("Übergebene Funktionswertberechnung nicht instanziert");
			if (_Messparameter == null)
				throw new ArgumentException("Übergebene Messparameter nicht instanziert");

			myFWB = _FWB;
			myMessparameter = _Messparameter;

			
		}
		
		public double Abbruchdifferential
		{
			get {
				return _Abbruchdifferential;
			}
			set {
				_Abbruchdifferential = value;
			}
				
		}
		
		public ModellParameter Optimiere2(Messwerte _Messwerte, ModellParameter _StartModellparameter)
		{
			
			if (_Abbruchdifferential == 0d)
				throw new ArgumentException ("Optimierung bis Betrag der größten partielle Ableitung kleiner null nicht möglich");
			
			
			Differenzierer myDiff = new Differenzierer(ref myFWB, 1.1d);
			
			Fehlerfunktion myFF = new Fehlerfunktion(myMessparameter);


			ModellParameter partialDiff = new ModellParameter(_StartModellparameter.NumberOBetasphericDimensions, _StartModellparameter.Vec2Length);
			ModellParameter TestModellparameter = new ModellParameter(_StartModellparameter.NumberOBetasphericDimensions, _StartModellparameter.Vec2Length);
			TestModellparameter = _StartModellparameter.ErstelleWertKopie(ref _StartModellparameter, ref TestModellparameter);

			ModellParameter RuecksicherungsParameter = new ModellParameter(_StartModellparameter.NumberOBetasphericDimensions, _StartModellparameter.Vec2Length);
			RuecksicherungsParameter = _StartModellparameter.ErstelleWertKopie(ref _StartModellparameter, ref RuecksicherungsParameter);
			

			double FehlerbewertungNachDifferenzierer;
			double FehlerbewertungNachAktuellemAbtastschritt;
			double FehleberwertungNachLetztemAbtastschritt = 10000000000000d;
			double Skalierung = 1d;


			bool VerfeinerePartielleAbtastung = false;
			
			
			// Zählvariablen
			int Iterationen = 0;
			int InnereIteration;
			int i;
			int AnzahlIterationenOhneFortschritt = 0;
			
			do {

				
				
				partialDiff = myDiff.Calc_partFF_nach_pModell_FastPath(ref _Messwerte, ref _StartModellparameter, ref partialDiff);
				
				FehlerbewertungNachDifferenzierer = myFF.BewerteRegression(ref _Messwerte, ref _StartModellparameter);
				
				
				
				InnereIteration = 1;
				do{
					
					
					if (InnereIteration == 1)
					{
						
						
						i = 0;
						do{
							Skalierung = Skalierung / 10;
							TestModellparameter = FolgeGradient(ref _StartModellparameter, ref TestModellparameter, ref partialDiff, Skalierung );
							FehlerbewertungNachAktuellemAbtastschritt = myFF.BewerteRegression(ref _Messwerte, ref TestModellparameter);
							
							if (Skalierung == 0)
							{
								Skalierung = 1;
								break;
							}
							

							if ( (FehlerbewertungNachAktuellemAbtastschritt == FehlerbewertungNachDifferenzierer) && (Skalierung < 1e-10))
							{
								if (myDiff.Abtastbreite > 1.00001)
									myDiff.Abtastbreite = 1 + (myDiff.Abtastbreite -1 )/ 10;
								Skalierung = 1;
								VerfeinerePartielleAbtastung = true;
								AnzahlIterationenOhneFortschritt++;
								

								if (AnzahlIterationenOhneFortschritt == 10)
								{
									RuecksicherungsParameter = TestModellparameter.ErstelleWertKopie(ref TestModellparameter, ref RuecksicherungsParameter);
								}
								if (AnzahlIterationenOhneFortschritt == 11)
								{
									if (10e-12 > RuecksicherungsParameter.BerechneMaximaleBetragsAbweichungZweierModellParameter(TestModellparameter, RuecksicherungsParameter))
									{
										return _StartModellparameter;
									}
								}
								
								break;
							}
							

							if (partialDiff.Maximum_dDeltaMat_dpartial() < _Abbruchdifferential)
							{
								_StartModellparameter.NormiereBetasSummenAufEins();
									return _StartModellparameter;
//								}
							}
							
							
							
							i++;
						} while (FehlerbewertungNachAktuellemAbtastschritt >= FehlerbewertungNachDifferenzierer);
						FehleberwertungNachLetztemAbtastschritt = FehlerbewertungNachAktuellemAbtastschritt;

						if (VerfeinerePartielleAbtastung == true)
						{
							VerfeinerePartielleAbtastung = false;
							break;
						}
					}

					else
					{
						

						AnzahlIterationenOhneFortschritt = 0;
						

						Skalierung = Skalierung * Math.Pow( (double) InnereIteration, 1.2d);
						
						if (true == Double.IsInfinity(Skalierung))
						{
							Skalierung = 1;
							break;
						}
							
						
						TestModellparameter = FolgeGradient(ref _StartModellparameter, ref TestModellparameter, ref partialDiff, Skalierung);
						FehlerbewertungNachAktuellemAbtastschritt = myFF.BewerteRegression(ref _Messwerte, ref TestModellparameter);
						if ( true == Double.IsNaN(FehlerbewertungNachAktuellemAbtastschritt))
						{
							Skalierung = Skalierung * Math.Pow( (double) InnereIteration, -2d);
							continue;
						}
				
						if ( (FehlerbewertungNachAktuellemAbtastschritt >= FehleberwertungNachLetztemAbtastschritt) || (true == double.IsNaN(FehlerbewertungNachAktuellemAbtastschritt)) || (true == double.IsInfinity(Skalierung))  )
						{
						
							
				
							Skalierung = Skalierung / Math.Pow( (double) InnereIteration, 1.2d );
							

							TestModellparameter = FolgeGradient(ref _StartModellparameter, ref TestModellparameter, ref partialDiff, Skalierung );

							

							

							_StartModellparameter = TestModellparameter.ErstelleWertKopie( ref TestModellparameter, ref _StartModellparameter);
							_StartModellparameter.NormiereAlphaSummenAufEins();

							break;

						}

						else
						{
							FehleberwertungNachLetztemAbtastschritt = FehlerbewertungNachAktuellemAbtastschritt;
							
						}
						
						
					}
					
					InnereIteration++;
				} while(InnereIteration < 100);

				
				Iterationen++;
			} while (Iterationen < 1000);
			
			
			

			
			
			_StartModellparameter.NormiereBetasSummenAufEins();
			return _StartModellparameter;
		}
		


		

		
		private ModellParameter FolgeGradient(ref ModellParameter Basis, ref ModellParameter NeueModellparameter, ref ModellParameter _Gradient,  double Skalierung)
		{
			if (_Gradient.IstGradient == false)
				throw new ArgumentException("Übergebene Gradient, ist nicht als solcher Markiert, evtl. handelt es sich um absolute Modellparameter");
			
			int j;

			
			
			for (int i = 0; i < NeueModellparameter.NumberOBetasphericDimensions; i++)
			{
				for (j = 0; j < NeueModellparameter.Vec2Length; j++)
				{
					
					
					NeueModellparameter.Betas[i,j] = Basis.Betas[i,j] -  _Gradient.Betas[i,j] * Skalierung;

					if (NeueModellparameter.Betas[i,j] < 0)
						NeueModellparameter.Betas[i,j] = 0;
				}
				NeueModellparameter.Gammas[i] = Basis.Gammas[i] - Basis.Gammas[i] * _Gradient.Gammas[i] * Skalierung;
				if (NeueModellparameter.Gammas[i] <= 0)
					NeueModellparameter.Gammas[i] = 1e-12;
			}
			NeueModellparameter.NormiereBetasSummenAufEins();
			return NeueModellparameter;
		}
	
	}
}
